#include <QtGui/QPainter>
#include <QtGui/QPaintEvent>
#include "widget.h"
#include "ui_widget.h"

Widget::Widget(QWidget *parent)
    : QWidget(parent), flag(true), ui(new Ui::WidgetClass)
{
    ui->setupUi(this);
    ui->lineEdit->installEventFilter(this);
}

bool Widget::eventFilter(QObject *o, QEvent *e)
{
    if (e->type() == QEvent::Paint && o->isWidgetType() && flag) {
        flag = false;
        QApplication::sendEvent(o, e);
        flag = true;

        paintOverWidget((QPaintEvent *)e, (QWidget *)o);

        return true;
    } else {
        return QObject::eventFilter(o, e);
    }
}

Widget::~Widget()
{
    delete ui;
}

void Widget::paintOverWidget(QPaintEvent *p, QWidget *w)
{
    if (w == ui->lineEdit) {
        QPainter painter(w);
        painter.setPen(Qt::gray);
        QFont font = painter.font();
        font.setPointSize(12);
        painter.setFont(font);
        painter.drawText(w->rect(), Qt::AlignCenter, QLatin1String("Code less, create more!"));
    }
}

